import React from 'react';
import { ViewProps, TouchableOpacityProps } from 'react-native';
import * as Progress from 'react-native-progress';
import type { IconProps } from 'react-native-vector-icons/Icon';
declare type Variant = 'normal' | 'compact';
interface RenderContentParams {
    readonly progress: number;
    readonly paused?: boolean;
    readonly thinking?: boolean;
}
interface NativeCircularStatusProps extends RenderContentParams, TouchableOpacityProps {
    readonly iconPause?: string;
    readonly iconPlay?: string;
    readonly iconThinking?: string;
    readonly icon?: string;
    renderContent?: ({ progress, paused }: RenderContentParams) => React.ReactNode;
    readonly variant?: Variant;
    readonly animated?: boolean;
    readonly strokeRound?: boolean;
    readonly colorPrimary?: string;
    readonly colorSecondary?: string;
    onPause?: (thinking: boolean) => void;
    onPlay?: (thinking: boolean) => void;
    onStatusChanged?: ({ paused, thinking, }: Required<Omit<RenderContentParams, 'progress'>>) => void;
    readonly disabled?: boolean;
    readonly contentProps?: ViewProps;
    readonly iconProps?: Partial<IconProps>;
    readonly placeholderProps?: ViewProps;
    readonly progressProps?: Progress.CirclePropTypes;
}
declare const NativeCircularStatus: ({ progress, iconPause, iconPlay, iconThinking, icon, paused, renderContent, variant, animated, strokeRound, colorPrimary, colorSecondary, onPause, onPlay, onStatusChanged, thinking, disabled, contentProps, iconProps, progressProps, ...containerProps }: NativeCircularStatusProps) => JSX.Element;
export default NativeCircularStatus;
