var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import Icon from 'native-icons';
import React, { useCallback, useEffect, useMemo, useState } from 'react';
import { TouchableOpacity, StyleSheet, View, } from 'react-native';
import * as Progress from 'react-native-progress';
var DEFAULTS = {
    ICON_PAUSE: 'square',
    ICON_PLAY: 'pause',
    COLOR_PRIMARY: '#fb2c53',
    COLOR_SECONDARY: '#efefef',
};
var PROGRESS_WIDTH = 2;
var ICON_SIZE = 10;
var SIZES = {
    COMPACT: 12,
    NORMAL: 28,
};
var NativeCircularStatus = function (_a) {
    var progress = _a.progress, _b = _a.iconPause, iconPause = _b === void 0 ? DEFAULTS.ICON_PAUSE : _b, _c = _a.iconPlay, iconPlay = _c === void 0 ? DEFAULTS.ICON_PLAY : _c, iconThinking = _a.iconThinking, icon = _a.icon, paused = _a.paused, renderContent = _a.renderContent, _d = _a.variant, variant = _d === void 0 ? 'normal' : _d, _e = _a.animated, animated = _e === void 0 ? true : _e, _f = _a.strokeRound, strokeRound = _f === void 0 ? true : _f, _g = _a.colorPrimary, colorPrimary = _g === void 0 ? DEFAULTS.COLOR_PRIMARY : _g, _h = _a.colorSecondary, colorSecondary = _h === void 0 ? DEFAULTS.COLOR_SECONDARY : _h, onPause = _a.onPause, onPlay = _a.onPlay, onStatusChanged = _a.onStatusChanged, _j = _a.thinking, thinking = _j === void 0 ? false : _j, disabled = _a.disabled, _k = _a.contentProps, contentProps = _k === void 0 ? {} : _k, _l = _a.iconProps, iconProps = _l === void 0 ? {} : _l, _m = _a.progressProps, progressProps = _m === void 0 ? {} : _m, containerProps = __rest(_a, ["progress", "iconPause", "iconPlay", "iconThinking", "icon", "paused", "renderContent", "variant", "animated", "strokeRound", "colorPrimary", "colorSecondary", "onPause", "onPlay", "onStatusChanged", "thinking", "disabled", "contentProps", "iconProps", "progressProps"]);
    var _o = useState(false), isLocalPaused = _o[0], setIsLocalPaused = _o[1];
    useEffect(function () {
        if (paused !== undefined) {
            setIsLocalPaused(paused);
        }
    }, [paused]);
    var handlePress = useCallback(function () {
        setIsLocalPaused(function (prevState) {
            var updatedState = thinking ? prevState : !prevState;
            if (prevState) {
                onPlay === null || onPlay === void 0 ? void 0 : onPlay(thinking);
            }
            else {
                onPause === null || onPause === void 0 ? void 0 : onPause(thinking);
            }
            onStatusChanged === null || onStatusChanged === void 0 ? void 0 : onStatusChanged({ paused: updatedState, thinking: thinking });
            return updatedState;
        });
    }, [onPause, onPlay, onStatusChanged, thinking]);
    var size = useMemo(function () {
        switch (variant) {
            case 'compact':
                return SIZES.COMPACT;
            case 'normal':
            default:
                return SIZES.NORMAL;
        }
    }, [variant]);
    var _p = containerProps.style, containerStyle = _p === void 0 ? {} : _p, containerRest = __rest(containerProps, ["style"]);
    var _q = contentProps.style, contentStyle = _q === void 0 ? {} : _q, contentRest = __rest(contentProps, ["style"]);
    var _r = iconProps.style, iconStyle = _r === void 0 ? {} : _r, iconRest = __rest(iconProps, ["style"]);
    var innerComponent = useMemo(function () {
        if (renderContent) {
            return renderContent({ progress: progress, paused: isLocalPaused, thinking: thinking });
        }
        if (thinking && !iconThinking && !icon) {
            return null;
        }
        if (isLocalPaused && !iconPlay && !icon) {
            return null;
        }
        if (!isLocalPaused && !iconPause && !icon) {
            return null;
        }
        return (React.createElement(Icon, __assign({ type: "ionicons", size: ICON_SIZE, color: colorPrimary, name: isLocalPaused ? iconPlay : iconPause, style: StyleSheet.flatten([styles.icon, iconStyle]) }, iconRest)));
    }, [
        renderContent,
        thinking,
        iconThinking,
        icon,
        isLocalPaused,
        iconPlay,
        iconPause,
        colorPrimary,
        iconStyle,
        iconRest,
        progress,
    ]);
    var isNormal = useMemo(function () { return variant === 'normal'; }, [variant]);
    var isThinkingEnabled = useMemo(function () { return thinking && isNormal; }, [isNormal, thinking]);
    return (React.createElement(TouchableOpacity, __assign({ onPress: handlePress, disabled: disabled, style: StyleSheet.flatten([
            styles.container,
            {
                width: size,
                height: size,
            },
            disabled ? styles.containerDisabled : {},
            containerStyle,
        ]) }, containerRest),
        (!thinking || (thinking && iconThinking)) && isNormal && (React.createElement(View, __assign({ style: StyleSheet.flatten([
                styles.content,
                styles.absoluteElement,
                contentStyle,
            ]) }, contentRest), innerComponent)),
        React.createElement(Progress.Circle, __assign({ animated: animated, indeterminate: isThinkingEnabled, borderWidth: isThinkingEnabled ? PROGRESS_WIDTH : 0, borderColor: colorSecondary, unfilledColor: isThinkingEnabled ? undefined : colorSecondary, color: colorPrimary, progress: progress, size: size, thickness: PROGRESS_WIDTH, fill: "#00000000" // TODO remove when https://github.com/oblador/react-native-progress/issues/234 is fixed
            , strokeCap: strokeRound ? 'round' : 'butt' }, progressProps))));
};
var styles = StyleSheet.create({
    container: {
        position: 'relative',
    },
    containerDisabled: {
        opacity: 0.5,
    },
    content: {
        justifyContent: 'center',
        alignItems: 'center',
    },
    absoluteElement: {
        position: 'absolute',
        width: '100%',
        height: '100%',
    },
    // TODO update or remove when https://github.com/oblador/react-native-vector-icons/issues/638#issuecomment-411349336 is fixed
    icon: {
        height: ICON_SIZE,
        width: ICON_SIZE,
        lineHeight: ICON_SIZE,
        textAlign: 'center',
    },
});
export default NativeCircularStatus;
